<template>
  <ob-form
      :form-data="formData"
      :form-model="formModel"
      :is-loading="isShowLoader"
      @submit="onSubmitHandler"
      okText="Добавить"
      data-qa="formGroupBP"
  >
    <div class="row">
      <div class="col-xs-12">
        <div class="form-group">
          <ob-input
            label="Наименование группы"
            v-model="formData.title"
            placeholder="Укажите наименование для группы"
            :required="true"
            @input="resetError"
            data-qa="inputDirectionTitleBP"
          />
        </div>
      </div>
      <div class="col-xs-12">
        <div class="form-group">
          <div class="form-group__title">Способ перевозки</div>
          <ObControlGroup
            :items="groupItems"
            v-model="formData.transportationWay"
            theme="light"
            height="slim"
            data-qa="controlGroupTransportationWayBP"
          />
        </div>
      </div>
    </div>

    <transition name="fadeIn">
      <ObAlert
          v-if="error"
          :text="error"
          class="alert-error"
          theme="danger"
          icon="alert"
          :hide-close-button="true"
      />
    </transition>

  </ob-form>
</template>

<script>
import api from '@/api';
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObAlert from "common-components/src/obComponents/obAlert";
import ObControlGroup from "common-components/src/obComponents/obControlGroup";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import { required } from "vuelidate/lib/validators";
import { transportationTypes } from "@/constants/basePrice.js";

export default {
  name: "BasePriceDirectionGroupForm",
  components: {
    ObForm,
    ObInput,
    ObAlert,
    ObControlGroup,
  },
  mixins: [FormValidationMixin, dropdownEvents],
  props: { },
  data () {
    return {
      error: '',
      isShowLoader: false,
      services: [],
      transportTypes: [],
      groupItems: transportationTypes,
    }
  },
  computed: {
    formModel() {
      return {
        title: {
          value: '',
          validator: {
            required
          }
        },
        transportationWay: {
          value: null,
          validator: {
            required
          }
        },
      }
    },
  },
  methods: {
    async onSubmitHandler() {
      let params = {...this.formData};
      this.isShowLoader = true;
      try {
        await api.base_prices_clustering.createDirectionGroup(params)
            .then((res) => {
              this.$notification({
                type: "system_notification_success",
                message: "Группа успешно создана",
              });
              this.$emit("save", {formData: res});
            })
            .catch((err) => {
              console.error("error ->", err);
              if (err.error) {
                this.error = err.error_message;
              }
            })
            .finally(() => {
              this.isShowLoader = false;
            });
      } catch (e) {
        this.isShowLoader = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка сохранения группы'});
        this.error = 'Ошибка сохранения группы';
      }
    },
    resetError() {
      this.error = '';
    },
    close() {
      this.$emit('close')
    },
  }
};
</script>

<style lang="scss">
@import "~common-components/src/static/css/mixins";
.form-group {
  justify-content: space-between;
  align-self: flex-start;
  margin-bottom: 20px;

  &__title {
    @include font-mixin(20px, 28px, 700, #191E32, 0.4px);
    margin-bottom: 10px;
  }

  &__label {
    @include font-mixin(14px, 18px, 400, #737682, 0.2px);
    margin-bottom: 15px;
  }

  .input-group .input{
    color: $cobalt-black;
  }
}
</style>